﻿'  Program Name: Assignment 3                                    
'  Author: Beatris A. Mendez. Gandica

' Import statements used
Imports MySql.Data.MySqlClient
Imports IST.DataHash

Public Class clsDatabase

    ' MySql Connection
    Private Shared MyConnection As String = My.Settings.DBConnection
    Private Shared connection As New MySqlConnection(MyConnection)

    ' Declaration of mysql
    Dim myReader As MySqlDataReader
    Dim article As MySqlDataReader

    ' Declaration of class Articles object
    Dim objArticles As clsArticles

    ' Declaration of user string variables
    Dim strFirstName As String
    Dim strLastName As String
    Dim strUsername As String
    Dim strPassword As String

    ' Declaration of MD5
    Dim MD5 As New MD5

    ' Function Encrypt a password value
    Public Function fcnEncrypt(ByVal value As String) As Object
        Try
            Dim encryption As Object = MD5.Encrypt(value)
            Return encryption
        Catch ex As Exception
            MessageBox.Show("There was an error while encrypting the password, try again.", "Error")
        End Try
        Return Nothing
    End Function

    ' Function createNewUser creates a new user and verify availability if username
    Function fcnCreateNewUser(ByRef strUsername, ByRef strPassword, ByRef strFirstName, ByRef strLastName)
        Try
            Dim insert As New MySqlCommand
            Dim myReader As MySqlDataReader
            Dim exists As New MySqlCommand

            'exists.CommandText = "SELECT userUsername FROM tblUser;"
            exists.CommandText = "CALL StoredProcedureCreateNewUserGetUsernames()"
            exists.CommandType = CommandType.Text
            exists.Connection = connection

            With insert
                '.CommandText = "INSERT INTO `mendezba`.`tblUser` (`userID`, `userUsername`, `userPassword`, `userFirstName`, `userLastName`) VALUES (NULL, '" & strUsername & "', '" & strPassword & "', '" & strFirstName & "', '" & strLastName & "');"
                .CommandText = "CALL StoredProcedureCreateNewUser('" & strUsername & "', '" & strPassword & "', '" & strFirstName & "', '" & strLastName & "');"

                .CommandType = CommandType.Text
                .Connection = connection
                connection.Open()
                myReader = exists.ExecuteReader()

                While myReader.Read
                    If myReader.GetValue(myReader.GetOrdinal("userUsername")) = strUsername Then
                        connection.Close()
                        Return 2

                    End If
                End While
                connection.Close()
            End With

            connection.Open()
            myReader = insert.ExecuteReader
            connection.Close()
            MessageBox.Show("You have successfully created a new user", "Success!")
        Catch ex As Exception
            MessageBox.Show("There was an error while connecting to the database please try again later.", "Error")
        End Try
        connection.Close()
        Return Nothing
    End Function

    ' Function Verifies username and password and if it valid will let the user login eventually
    Function fcnVerifyCredentials(ByVal strUsername, ByVal strPassword)
        Try
            Dim MD5 As New MD5

            Dim connection As New MySqlConnection
            connection.ConnectionString = My.Settings.DBConnection

            Dim command As New MySqlCommand
            command.Connection = connection
            ' command.CommandText = "SELECT * FROM tblUser WHERE userUsername = '" & strUsername & "';"
            command.CommandText = "CALL StoredProcedureVerifyCredentials('" & strUsername & "')"
            command.Connection = connection

            If connection.State = ConnectionState.Closed Then
                connection.Open()
            End If

            Dim myReader As MySqlDataReader = command.ExecuteReader()

            While myReader.Read()

                ' Set the variables for the User's data
                If MD5.Verify(strPassword, myReader.GetValue(myReader.GetOrdinal("userPassword"))) = True Then
                    myReader.Close()
                    connection.Close()
                    Return True
                    'MessageBox.Show("Success") '"Success"
                Else
                    myReader.Close()
                    connection.Close()
                    Return Nothing
                End If
                myReader.Close()
                connection.Close()
            End While
            myReader.Close()
            connection.Close()
        Catch ex As Exception
            MessageBox.Show("There was an error while connecting to the database please try again later.", "Error")
        End Try
        connection.Close()
        Return Nothing
    End Function

    ' Function Get user info (userID, username, firstname, lastname) and put it into clsUser
    Function fcnGetUserInfo(ByVal strUsername, ByVal strPassword)
        Try
            Dim MD5 As New MD5

            Dim connection As New MySqlConnection
            connection.ConnectionString = My.Settings.DBConnection

            Dim command As New MySqlCommand
            command.Connection = connection
            'command.CommandText = "SELECT * FROM tblUser WHERE userUsername = '" & strUsername & "';"
            command.CommandText = "CALL StoredProcedureGetUserInfo('" & strUsername & "')"

            command.Connection = connection

            If connection.State = ConnectionState.Closed Then
                connection.Open()
            End If

            Dim myReader As MySqlDataReader = command.ExecuteReader()

            While myReader.Read()

                ' Set the variables for the User's data
                If MD5.Verify(strPassword, myReader.GetValue(myReader.GetOrdinal("userPassword"))) = True Then
                    clsUser.propertyUserID = myReader.GetValue(myReader.GetOrdinal("userID"))
                    clsUser.propertyUsername = myReader.GetValue(myReader.GetOrdinal("userUsername"))
                    clsUser.propertyLoginFirstName = myReader.GetValue(myReader.GetOrdinal("userFirstName"))
                    clsUser.propertyLoginLastName = myReader.GetValue(myReader.GetOrdinal("userLastName"))
                    myReader.Close()
                    connection.Close()
                    Return True
                    'MessageBox.Show("Success") '"Success"
                Else
                    myReader.Close()
                    connection.Close()
                    Return Nothing
                End If
                myReader.Close()
                connection.Close()
            End While
            myReader.Close()
            connection.Close()
        Catch ex As Exception
            MessageBox.Show("There was an error while connecting to the database please try again later.", "Error")
        End Try
        connection.Close()
        Return Nothing
    End Function

    ' Function Submit New Articles
    Function fcnSubmitArticles(ByRef strNewArticleTitleName As String, ByRef strURL As String, ByRef strDescriptionForNewArticle As String, ByRef strCategory As String)
        Try
            Dim connn As New MySqlConnection(MyConnection)
            Dim cmd As New MySqlCommand()

            connn.Open()
            cmd.Connection = connn

            ' cmd.CommandText = "INSERT INTO tblArticle(artTitle, artURL, artDescription, artCategory) VALUES('" & strNewArticleTitleName & "', '" & strURL & "', '" & strDescriptionForNewArticle & "', '" & strCategory & "')"
            cmd.CommandText = "CALL StoredProcedureSubmitArticles('" & strNewArticleTitleName & "', '" & strURL & "', '" & strDescriptionForNewArticle & "', '" & strCategory & "')"
            cmd.Prepare()

            'cmd.Parameters.AddWithValue("@Name", "Bea Gandica")
            cmd.ExecuteNonQuery()

            connn.Close()
            Return MessageBox.Show("Congrats, Thank you for the new article.")

        Catch ex As MySqlException
            Return 0
            'Console.WriteLine("Error: " & ex.ToString())
        End Try
        connection.Close()
        Return Nothing
    End Function

    ' Function Update NEW Article Count
    Function fcnUpdateNewArticleCount(ByVal intVotes As Integer, ByVal strArticleName As String)
        Try

            Dim connection As New MySqlConnection
            connection.ConnectionString = My.Settings.DBConnection

            ' CHECK HERE
            Dim command As New MySqlCommand


            With command                'updates the database for when a user upvotes or downvotes a new article
                '.CommandText = "UPDATE tblArticle SET artVotes = ('" & strVotes & "') WHERE artTitle = '" & strArticleName & "'"
                .CommandText = "CALL StoredProcedureUpdateNewArticleCount('" & intVotes & "','" & strArticleName & "')"
                .Connection = connection
            End With
            If connection.State = ConnectionState.Closed Then
                connection.Open()
            End If
            command.ExecuteNonQuery()
            connection.Close()
        Catch ex As Exception
            MessageBox.Show("There was an error while connecting to the database please try again later.", "Error")
        End Try
        connection.Close()
        Return Nothing
    End Function

    ' Function Update TOP Article count
    Function fcnUpdateTopArticleCount(ByVal intVotes As Integer, ByVal strArticleName As String)
        Try
            Dim connection As New MySqlConnection
            connection.ConnectionString = My.Settings.DBConnection

            ' CHECK HERE
            Dim command As New MySqlCommand


            With command                'updates the database for when a user upvotes or downvotes a new article
                '.CommandText = "UPDATE tblArticle SET artVotes = ('" & strVotes & "') WHERE artTitle = '" & strArticleName & "'"
                .CommandText = "CALL StoredProcedureUpdateTopArticleCount('" & intVotes & "','" & strArticleName & "')"
                .Connection = connection
            End With
            If connection.State = ConnectionState.Closed Then
                connection.Open()
            End If
            command.ExecuteNonQuery()
            connection.Close()
        Catch ex As Exception
            MessageBox.Show("There was an error while connecting to the database please try again later.", "Error")
        End Try
        connection.Close()
        Return Nothing
    End Function

    ' Function Load "NEW Articles" on Form Load after Login - poplates text fields and labels
    Function fcnLoadNewArticles()
        Try

            Dim connection As New MySqlConnection
            connection.ConnectionString = My.Settings.DBConnection

            Dim command As New MySqlCommand
            command.Connection = connection
            ' command.CommandText = "SELECT * FROM tblArticle ORDER BY artDate DESC LIMIT 3"
            command.CommandText = "CALL StoredProcedureLoadNewArticles()"
            command.Connection = connection

            If connection.State = ConnectionState.Closed Then
                connection.Open()
            End If

            Dim myReader As MySqlDataReader = command.ExecuteReader()

            Dim intReaderCounterNew As Integer = 0

            While myReader.Read()
                'MessageBox.Show((myReader.GetValue(myReader.GetOrdinal("artTitle"))))
                If intReaderCounterNew = 0 Then
                    clsArticles.propertyNewArticle1Title = myReader.GetValue(myReader.GetOrdinal("artTitle"))
                    clsArticles.propertyNewArticle1Date = myReader.GetValue(myReader.GetOrdinal("artDate"))
                    clsArticles.propertyNewArticle1Category = myReader.GetValue(myReader.GetOrdinal("artCategory"))
                    clsArticles.propertyNewArticle1Votes = myReader.GetValue(myReader.GetOrdinal("artVotes"))
                    clsArticles.propertyNewArticle1Description = myReader.GetValue(myReader.GetOrdinal("artDescription"))
                    clsArticles.propertyNewArticle1URL = myReader.GetValue(myReader.GetOrdinal("artURL"))
                    intReaderCounterNew = intReaderCounterNew + 1
                ElseIf intReaderCounterNew = 1 Then
                    clsArticles.propertyNewArticle2Title = myReader.GetValue(myReader.GetOrdinal("artTitle"))
                    clsArticles.propertyNewArticle2Date = myReader.GetValue(myReader.GetOrdinal("artDate"))
                    clsArticles.propertyNewArticle2Category = myReader.GetValue(myReader.GetOrdinal("artCategory"))
                    clsArticles.propertyNewArticle2Votes = myReader.GetValue(myReader.GetOrdinal("artVotes"))
                    clsArticles.propertyNewArticle2Description = myReader.GetValue(myReader.GetOrdinal("artDescription"))
                    clsArticles.propertyNewArticle2URL = myReader.GetValue(myReader.GetOrdinal("artURL"))
                    intReaderCounterNew = intReaderCounterNew + 1
                Else
                    clsArticles.propertyNewArticle3Title = myReader.GetValue(myReader.GetOrdinal("artTitle"))
                    clsArticles.propertyNewArticle3Date = myReader.GetValue(myReader.GetOrdinal("artDate"))
                    clsArticles.propertyNewArticle3Category = myReader.GetValue(myReader.GetOrdinal("artCategory"))
                    clsArticles.propertyNewArticle3Votes = myReader.GetValue(myReader.GetOrdinal("artVotes"))
                    clsArticles.propertyNewArticle3Description = myReader.GetValue(myReader.GetOrdinal("artDescription"))
                    clsArticles.propertyNewArticle3URL = myReader.GetValue(myReader.GetOrdinal("artURL"))
                End If

            End While
            myReader.Close()
            connection.Close()
        Catch ex As Exception
            MessageBox.Show("There was an error while connecting to the database please try again later.", "Error")
        End Try
        connection.Close()
        Return Nothing
    End Function

    ' Function Load "TOP Articles" on Form Load after Login - poplates text fields and labels
    Function fcnLoadTopArticles()
        Try
            Dim connection As New MySqlConnection
            connection.ConnectionString = My.Settings.DBConnection

            Dim command As New MySqlCommand
            command.Connection = connection
            'command.CommandText = "SELECT * FROM tblArticle ORDER BY artVotes DESC LIMIT 3"
            command.CommandText = "CALL StoredProcedureLoadTopArticles()"
            command.Connection = connection

            If connection.State = ConnectionState.Closed Then
                connection.Open()
            End If

            Dim myReader As MySqlDataReader = command.ExecuteReader()

            Dim intReaderCounter As Integer = 0

            While myReader.Read()
                ' MessageBox.Show((myReader.GetValue(myReader.GetOrdinal("artTitle"))))
                If intReaderCounter = 0 Then
                    clsArticles.propertyTopArticle1Title = myReader.GetValue(myReader.GetOrdinal("artTitle"))
                    clsArticles.propertyTopArticle1Date = myReader.GetValue(myReader.GetOrdinal("artDate"))
                    clsArticles.propertyTopArticle1Category = myReader.GetValue(myReader.GetOrdinal("artCategory"))
                    clsArticles.propertyTopArticle1Votes = myReader.GetValue(myReader.GetOrdinal("artVotes"))
                    clsArticles.propertyTopArticle1Description = myReader.GetValue(myReader.GetOrdinal("artDescription"))
                    clsArticles.propertyTopArticle1URL = myReader.GetValue(myReader.GetOrdinal("artURL"))
                    intReaderCounter = intReaderCounter + 1
                ElseIf intReaderCounter = 1 Then
                    clsArticles.propertyTopArticle2Title = myReader.GetValue(myReader.GetOrdinal("artTitle"))
                    clsArticles.propertyTopArticle2Date = myReader.GetValue(myReader.GetOrdinal("artDate"))
                    clsArticles.propertyTopArticle2Category = myReader.GetValue(myReader.GetOrdinal("artCategory"))
                    clsArticles.propertyTopArticle2Votes = myReader.GetValue(myReader.GetOrdinal("artVotes"))
                    clsArticles.propertyTopArticle2Description = myReader.GetValue(myReader.GetOrdinal("artDescription"))
                    clsArticles.propertyTopArticle2URL = myReader.GetValue(myReader.GetOrdinal("artURL"))
                    intReaderCounter = intReaderCounter + 1
                Else
                    clsArticles.propertyTopArticle3Title = myReader.GetValue(myReader.GetOrdinal("artTitle"))
                    clsArticles.propertyTopArticle3Date = myReader.GetValue(myReader.GetOrdinal("artDate"))
                    clsArticles.propertyTopArticle3Category = myReader.GetValue(myReader.GetOrdinal("artCategory"))
                    clsArticles.propertyTopArticle3Votes = myReader.GetValue(myReader.GetOrdinal("artVotes"))
                    clsArticles.propertyTopArticle3Description = myReader.GetValue(myReader.GetOrdinal("artDescription"))
                    clsArticles.propertyTopArticle3URL = myReader.GetValue(myReader.GetOrdinal("artURL"))
                End If

            End While
            myReader.Close()
            connection.Close()
        Catch ex As Exception
            MessageBox.Show("There was an error while connecting to the database please try again later.", "Error")
        End Try
        connection.Close()
        Return Nothing
    End Function

    ' Function Populates the New Articles Category ComboBox
    Function fcnGetCategories(ByVal box As ComboBox)
        Try
            Dim connection As New MySqlConnection
            connection.ConnectionString = My.Settings.DBConnection

            Dim command As New MySqlCommand
            ' command.CommandText = "SELECT * FROM tblArtCategories"
            command.CommandText = "CALL StoredProcedureGetCategories()"
            command.CommandType = CommandType.Text
            command.Connection = connection
            Dim myReader As MySqlDataReader
            If connection.State = ConnectionState.Closed Then
                connection.Open()
            End If
            'adds article title to the list box
            myReader = command.ExecuteReader()
            While myReader.Read()
                box.Items.Add(myReader.GetValue(myReader.GetOrdinal("catName")))
            End While
            connection.Close()
            'if there is an error in the connection display the following message
        Catch ex As Exception
            MessageBox.Show("There was an error while connecting to the database please try again later.", "Error")
        End Try
        connection.Close()
        Return Nothing
    End Function

End Class

