﻿'  Program Name: Assignment 3                                    
'  Author: Bea A. Mendez. Gandica

' Import statements
Imports System
Imports System.Windows.Forms
Imports System.Text.RegularExpressions

Public Class frmArticles

    ' Declarations
    Dim objclsUser As New clsUser
    Dim objDatabase As New clsDatabase
    Dim objArticles As New clsArticles

    ' Load TOP article properties to the form
    Function fcnReloadTopArticlesLabels()

        ' Load the clsArticles TOP ARTICLE properties
        objDatabase.fcnLoadTopArticles()

        '  TOP Article 1 Load/Refresh
        linklblTopArticle1.Text = objArticles.GetValueTopArticleOneTitle()
        lblTimeTopArticle1.Text = objArticles.GetValueTopArticleOneSubmissionTime()
        ' check
        lblCategoryTopArticle1.Text = objArticles.GetValueTopArticleOneCategory()
        lblVotesTopArticle1.Text = objArticles.GetValueTopArticleOneTotalVoteAmount()
        lblTopArticleDescription1.Text = objArticles.GetValueTopArticleOneDescription()

        ' TOP Article 2 Load/Refresh
        linklblTopArticle2.Text = objArticles.GetValueTopArticleTwoTitle()
        lblTimeTopArticle2.Text = objArticles.GetValueTopArticleTwoSubmissionTime()
        lblCategoryTopArticle2.Text = objArticles.GetValueTopArticleTwoCategory()
        lblVotesTopArticle2.Text = objArticles.GetValueTopArticleTwoTotalVoteAmount()
        lblTopArticleDescription2.Text = objArticles.GetValueTopArticleTwoDescription()

        ' TOP Article 3 Load/Refresh
        linklblTopArticle3.Text = objArticles.GetValueTopArticleThreeTitle()
        lblTimeTopArticle3.Text = objArticles.GetValueTopArticleThreeSubmissionTime()
        lblCategoryTopArticle3.Text = objArticles.GetValueTopArticleThreeCategory()
        lblVotesTopArticle3.Text = objArticles.GetValueTopArticleThreeTotalVoteAmount()
        lblTopArticleDescription3.Text = objArticles.GetValueTopArticleThreeDescription()

        Return Nothing

    End Function

    ' Load NEW article properties to the form
    Function fcnReloadNewArticlesLabels()

        ' Load the clsArticles NEW ARTICLE properties
        objDatabase.fcnLoadNewArticles()

        ' NEW ARTICLE 1 load/refresh
        linklblNewArticle1.Text = objArticles.GetValueNewArticleOneTitle()
        lblTimeNewArticle1.Text = objArticles.GetValueNewArticleOneSubmissionTime()
        ' check
        lblCategoryNewArticle1.Text = objArticles.GetValueNewArticleOneCategory()
        lblVotesNewArticle1.Text = objArticles.GetValueNewArticleOneTotalVoteAmount()
        lblNewArticleDescription1.Text = objArticles.GetValueNewArticleOneDescription()

        ' NEW ARTICLE 2 load/refresh
        linklblNewArticle2.Text = objArticles.GetValueNewArticleTwoTitle()
        lblTimeNewArticle2.Text = objArticles.GetValueNewArticleTwoSubmissionTime()
        lblCategoryNewArticle2.Text = objArticles.GetValueNewArticleTwoCategory()
        lblVotesNewArticle2.Text = objArticles.GetValueNewArticleTwoTotalVoteAmount()
        lblNewArticleDescription2.Text = objArticles.GetValueNewArticleTwoDescription()

        ' NEW ARTICLE 3 load/refresh
        linklblNewArticle3.Text = objArticles.GetValueNewArticleThreeTitle()
        lblTimeNewArticle3.Text = objArticles.GetValueNewArticleThreeSubmissionTime()
        lblCategoryNewArticle3.Text = objArticles.GetValueNewArticleThreeCategory()
        lblVotesNewArticle3.Text = objArticles.GetValueNewArticleThreeTotalVoteAmount()
        lblNewArticleDescription3.Text = objArticles.GetValueNewArticleThreeDescription()

        Return Nothing

    End Function


    ' Form load method
    Private Sub frmArticles_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' Assign name and last name to current user from clsUser
        lblFirstNameTopArticles.Text = objclsUser.fcnGetUserNameForCurrentUser()
        lblFirstNameNewArticles.Text = objclsUser.fcnGetUserNameForCurrentUser()


        ' Reload New Article Data
        fcnReloadNewArticlesLabels()


        ' Reload Top Article Data
        fcnReloadTopArticlesLabels()

        ' Categories Loaded
        objDatabase.fcnGetCategories(cboCategory)

    End Sub ' END OF THE LOAD SUBROUTINE

    ' FORM CLOSE EVENT
    Private Sub frmPostedArticles_Close(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.FormClosed
        'to close the login form
        frmLogin.Close()
    End Sub

    '/      NEW ARTICLES VOTING SYSTEM - BEGIN

    ' First link clicked - add hyperlink
    Private Sub linklblNewArticle1_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles linklblNewArticle1.LinkClicked
        System.Diagnostics.Process.Start(objArticles.GetValueNewArticleOneHTML())
    End Sub

    ' Second link clicked - add hyperlink
    Private Sub linklblNewArticle2_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles linklblNewArticle2.LinkClicked
        System.Diagnostics.Process.Start(objArticles.GetValueNewArticleTwoHTML())
    End Sub

    ' Third link clicked - add hyperlink
    Private Sub linklblNewArticle3_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles linklblNewArticle3.LinkClicked
        System.Diagnostics.Process.Start(objArticles.GetValueNewArticleThreeHTML())
    End Sub

    ' Like click - call CheckVotes and send specific data so it knows where the click happened and to either add or subtract
    Private Sub btnLikeNewArticle1_Click(sender As System.Object, e As System.EventArgs) Handles btnLikeNewArticle1.Click

        ' Sending VOTES integer (text) and ARTICLE NAME to update votes
        objDatabase.fcnUpdateNewArticleCount((CInt(lblVotesNewArticle1.Text) + 1), linklblNewArticle1.Text)

        ' Reload Top Article Data
        fcnReloadTopArticlesLabels()

        ' Reload New Article Data
        fcnReloadNewArticlesLabels()

    End Sub

    ' Dislike click - call CheckVotes and send specific data so it knows where the click happened and to either add or subtract
    Private Sub btnDislikeNewArticle1_Click(sender As System.Object, e As System.EventArgs) Handles btnDislikeNewArticle1.Click

        ' Sending VOTES integer (text) and ARTICLE NAME to update votes
        objDatabase.fcnUpdateNewArticleCount((CInt(lblVotesNewArticle1.Text) - 1), linklblNewArticle1.Text)

        ' Reload Top Article Data
        fcnReloadTopArticlesLabels()

        ' Reload New Article Data
        fcnReloadNewArticlesLabels()

    End Sub

    ' Like click - call CheckVotes and send specific data so it knows where the click happened and to either add or subtract
    Private Sub btnLikeNewArticle2_Click(sender As System.Object, e As System.EventArgs) Handles btnLikeNewArticle2.Click

        ' Sending VOTES integer (text) and ARTICLE NAME to update votes
        objDatabase.fcnUpdateNewArticleCount((CInt(lblVotesNewArticle2.Text) + 1), linklblNewArticle2.Text)

        ' Reload Top Article Data
        fcnReloadTopArticlesLabels()

        ' Reload New Article Data
        fcnReloadNewArticlesLabels()

    End Sub

    ' Dislike click - call CheckVotes and send specific data so it knows where the click happened and to either add or subtract
    Private Sub btnDislikeNewArticle2_Click(sender As System.Object, e As System.EventArgs) Handles btnDislikeNewArticle2.Click

        ' Sending VOTES integer (text) and ARTICLE NAME to update votes
        objDatabase.fcnUpdateNewArticleCount((CInt(lblVotesNewArticle2.Text) - 1), linklblNewArticle2.Text)

        ' Reload Top Article Data
        fcnReloadTopArticlesLabels()

        ' Reload New Article Data
        fcnReloadNewArticlesLabels()

    End Sub

    ' Like click - call CheckVotes and send specific data so it knows where the click happened and to either add or subtract
    Private Sub btnLikeNewArticle3_Click(sender As System.Object, e As System.EventArgs) Handles btnLikeNewArticle3.Click

        ' Sending VOTES integer (text) and ARTICLE NAME to update votes
        objDatabase.fcnUpdateNewArticleCount((CInt(lblVotesNewArticle3.Text) + 1), linklblNewArticle3.Text)

        ' Reload Top Article Data
        fcnReloadTopArticlesLabels()

        ' Reload New Article Data
        fcnReloadNewArticlesLabels()

    End Sub

    ' Dislike click - call CheckVotes and send specific data so it knows where the click happened and to either add or subtract
    Private Sub btnDislikeNewArticle3_Click(sender As System.Object, e As System.EventArgs) Handles btnDislikeNewArticle3.Click

        ' Sending VOTES integer (text) and ARTICLE NAME to update votes
        objDatabase.fcnUpdateNewArticleCount((CInt(lblVotesNewArticle3.Text) - 1), linklblNewArticle3.Text)

        ' Reload Top Article Data
        fcnReloadTopArticlesLabels()

        ' Reload New Article Data
        fcnReloadNewArticlesLabels()

    End Sub

    '*************'*************'*************'*************'*************
    '
    ' Dim objArticleSubmission As New clsDatabase
    '
    '*************'*************'*************'*************'*************
    Private Sub btnSubmitNewArticle_Click(sender As System.Object, e As System.EventArgs) Handles btnSubmitNewArticle.Click

        Dim strErrors As String
        strErrors = ""

        If txtURL.Text = "" Then
            strErrors = strErrors & "Please type URL" & vbCrLf
        ElseIf Not Regex.IsMatch(txtURL.Text, "^http\://[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3}(/\S*)?$") Then
            strErrors = strErrors & "Please type a Valid URL, Example: http://www.google.com/" & vbCrLf
        End If

        If txtTitleForNewArticleSubmission.Text = "" Then
            strErrors = strErrors & "Please type Article Title" & vbCrLf
        End If

        If txtDescriptionForNewArticle.Text = "" Then
            strErrors = strErrors & "Please type Article Description" & vbCrLf
        End If

        If cboCategory.Text() = "" Then
            strErrors = strErrors & "Please select a Category" & vbCrLf
        End If

        If strErrors <> "" Then
            MessageBox.Show(strErrors)
        Else
            ' Send Valid Data To MySql Database
            objDatabase.fcnSubmitArticles(txtTitleForNewArticleSubmission.Text, txtURL.Text, txtDescriptionForNewArticle.Text, cboCategory.Text)

            ' Reload Top Article Data
            fcnReloadTopArticlesLabels()

            ' Reload New Article Data
            fcnReloadNewArticlesLabels()

            ' Clear textfields
            txtTitleForNewArticleSubmission.Clear()
            txtURL.Clear()
            txtDescriptionForNewArticle.Clear()

        End If

    End Sub

    ' Submit new article section END

    ' TOP ARTICLES SECTION COMPLETED - START

    ' FOR THE TOP Article HYPERLINKS 
    Private Sub linklblTopArticle1_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles linklblTopArticle1.LinkClicked
        System.Diagnostics.Process.Start(objArticles.GetValueTopArticleOneHTML())
    End Sub

    ' FOR THE TOP Article HYPERLINKS 
    Private Sub linklblTopArticle2_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles linklblTopArticle2.LinkClicked
        System.Diagnostics.Process.Start(objArticles.GetValueTopArticleTwoHTML())
    End Sub

    ' FOR THE TOP Article HYPERLINKS 
    Private Sub linklblTopArticle3_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles linklblTopArticle3.LinkClicked
        System.Diagnostics.Process.Start(objArticles.GetValueTopArticleThreeHTML())
    End Sub

    ' Simple VOTING for TOP ARTICLES section below

    ' FIRST TOP ARTICLES LINK
    Private Sub btnLikeTopArticle1_Click(sender As System.Object, e As System.EventArgs) Handles btnLikeTopArticle1.Click


        ' Sending VOTES integer (text) and ARTICLE NAME to update votes
        objDatabase.fcnUpdateTopArticleCount((CInt(lblVotesTopArticle1.Text) + 1), linklblTopArticle1.Text)

        ' Reload Top Article Data
        fcnReloadTopArticlesLabels()

        ' Reload New Article Data
        fcnReloadNewArticlesLabels()

    End Sub

    ' FIRST TOP ARTICLES LINK
    Private Sub btnDislikeTopArticle1_Click(sender As System.Object, e As System.EventArgs) Handles btnDislikeTopArticle1.Click

        ' Sending VOTES integer (text) and ARTICLE NAME to update votes
        objDatabase.fcnUpdateTopArticleCount((CInt(lblVotesTopArticle1.Text) - 1), linklblTopArticle1.Text)

        ' Reload Top Article Data
        fcnReloadTopArticlesLabels()

        ' Reload New Article Data
        fcnReloadNewArticlesLabels()

    End Sub

    ' SECOND TOP ARTICLES LINK
    Private Sub btnLikeTopArticle2_Click(sender As System.Object, e As System.EventArgs) Handles btnLikeTopArticle2.Click

        ' Sending VOTES integer (text) and ARTICLE NAME to update votes
        objDatabase.fcnUpdateTopArticleCount((CInt(lblVotesTopArticle2.Text) + 1), linklblTopArticle2.Text)

        ' Reload Top Article Data
        fcnReloadTopArticlesLabels()

        ' Reload New Article Data
        fcnReloadNewArticlesLabels()

    End Sub

    ' SECOND TOP ARTICLES LINK
    Private Sub btnDislikeTopArticle2_Click(sender As System.Object, e As System.EventArgs) Handles btnDislikeTopArticle2.Click

        ' Sending VOTES integer (text) and ARTICLE NAME to update votes
        objDatabase.fcnUpdateTopArticleCount((CInt(lblVotesTopArticle2.Text) - 1), linklblTopArticle2.Text)

        ' Reload Top Article Data
        fcnReloadTopArticlesLabels()

        ' Reload New Article Data
        fcnReloadNewArticlesLabels()
    End Sub

    ' THIRD TOP ARTICLES LINK
    Private Sub btnLikeTopArticle3_Click(sender As System.Object, e As System.EventArgs) Handles btnLikeTopArticle3.Click

        ' Sending VOTES integer (text) and ARTICLE NAME to update votes
        objDatabase.fcnUpdateTopArticleCount((CInt(lblVotesTopArticle3.Text) + 1), linklblTopArticle3.Text)

        ' Reload Top Article Data
        fcnReloadTopArticlesLabels()

        ' Reload New Article Data
        fcnReloadNewArticlesLabels()
    End Sub

    ' THIRD TOP ARTICLES LINK
    Private Sub btnDislikeTopArticle3_Click(sender As System.Object, e As System.EventArgs) Handles btnDislikeTopArticle3.Click

        ' Sending VOTES integer (text) and ARTICLE NAME to update votes
        objDatabase.fcnUpdateTopArticleCount((CInt(lblVotesTopArticle3.Text) - 1), linklblTopArticle3.Text)

        ' Reload Top Article Data
        fcnReloadTopArticlesLabels()

        ' Reload New Article Data
        fcnReloadNewArticlesLabels()
    End Sub

    ' TOP ARTICLES SECTION COMPLETED - END

End Class